package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zhios_condition_statistics_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils/logx"
	"fmt"
	"time"
	"xorm.io/xorm"
)

// OrderListCountByUIDByOrderTypeByTime is 查询订单 by uid by time ,获取规定时间内的订单类型的订单数
func OrderListCountByUIDByOrderTypeByTimeNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (int64, error) {

	state := []string{"1", "2", "3", "5"}
	timeType := "confirm_at"
	if task.OrdState == 1 { //已付款
		timeType = "create_at"
		state = []string{"0", "1", "2", "3", "5"}
	}
	timeType2 := "created_at"
	timeType4 := "create_time"
	if task.OrdState == 3 {
		timeType = "settle_at"
		timeType2 = "settle_at"
		timeType4 = "settle_at"
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location())
	etime := t
	var total int64 = 0
	sess := Db.Where("uid = ?  and settle_at=0", uid)
	sess1 := Db.Where("uid = ?  and settle_at>0", uid)
	sess2 := Db.Where("uid = ?", uid)
	sess4 := Db.Where("uid = ?", uid)
	if task.WithinDays > 0 {
		sqlStr := fmt.Sprintf(" %s > %d AND %s < %d", timeType, stime.Unix(), timeType, etime.Unix())
		sess = sess.And(sqlStr)
		sess1 = sess1.And(sqlStr)
		sqlStr2 := fmt.Sprintf(" %s > %d AND %s < %d", timeType2, stime.Unix(), timeType2, etime.Unix())
		sess2 = sess2.And(sqlStr2)
		sqlStr4 := fmt.Sprintf(" %s >'%s' AND %s < '%s'", timeType4, stime.Format("2006-01-02 15:04:05"), timeType4, etime.Format("2006-01-02 15:04:05"))
		sess4 = sess4.And(sqlStr4)
	}
	if task.OrdState == 3 {
		sess2 = sess2.And("settle_at>0")
		sess4 = sess4.And("settle_at>0")
	}
	var err error
	if task.OrdState != 3 {
		total, err = sess.In("state", state).Count(&model.OrdList{})
		fmt.Println(err)
		if task.OrdState != 1 {
			total3, _ := Db.Where("uid = ?  AND settle_at > ? AND settle_at < ? and confirm_at=0", uid, stime, etime).Count(&model.OrdList{})
			total += total3
		}
	}
	total1, _ := sess1.Count(&model.OrdList{})
	total2, _ := sess2.Where("state=?", uid, 1).Count(&model.PrivilegeCardOrd{})
	total4, _ := sess4.Where("status=?", uid, "已付款").Count(&model.RechargeOrder{})

	fmt.Println(total)

	return total + total1 + total2 + total4, nil
}

func MallOrdWithCountNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (int64, error) {
	state := []string{"2", "3"}
	timeType := "confirm_time"
	if task.OrdState == 1 { //已付款
		timeType = "create_time"
		state = []string{"1", "2", "3"}
	}
	if task.OrdState == 3 {
		timeType = "settle_time"
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05")
	etime := t.Format("2006-01-02 15:04:05")
	sess := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sqlStr := fmt.Sprintf(" %s >'%s' AND %s < '%s'", timeType, stime, timeType, etime)
		sess.And(sqlStr)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	}
	if task.OrdState != 3 {
		sess.In("state", state)
	}

	total, err := sess.Count(&model.MallOrd{})
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
func O2oOrdWithCountNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (int64, error) {
	state := []string{"2", "3"}
	timeType := "confirm_time"
	timeType1 := "create_time"
	if task.OrdState == 1 { //已付款
		timeType = "create_time"
		state = []string{"1", "2", "3"}
	}
	if task.OrdState == 3 {
		timeType = "settle_time"
		timeType1 = "settle_time"

	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05")
	etime := t.Format("2006-01-02 15:04:05")
	sess := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sqlStr := fmt.Sprintf(" %s >'%s' AND %s < '%s'", timeType, stime, timeType, etime)
		sess.And(sqlStr)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	}
	if task.OrdState != 3 {
		sess.In("state", state)
	}
	total, err := sess.Count(&model.O2oOrd{})
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	sess1 := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sqlStr := fmt.Sprintf(" %s >'%s' AND %s < '%s'", timeType1, stime, timeType1, etime)
		sess1.And(sqlStr)
	}
	if task.OrdState == 3 {
		sess1.And("settle_time is not null")
	} else {
		sess1.And("state in (?)", "1,4")
	}
	total1, err1 := sess1.Count(&model.O2oPayToMerchant{})
	if err1 != nil {
		return total, zhios_condition_statistics_logx.Error(err)
	}
	total += total1
	return total, nil
}
func B2cOrdWithCountNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (int64, error) {
	state := []string{"2", "3"}
	timeType := "confirm_time"
	if task.OrdState == 1 { //已付款
		timeType = "create_time"
		state = []string{"1", "2", "3"}
	}
	if task.OrdState == 3 {
		timeType = "settle_time"
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05")
	etime := t.Format("2006-01-02 15:04:05")
	sess := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sqlStr := fmt.Sprintf(" %s >'%s' AND %s < '%s'", timeType, stime, timeType, etime)
		sess.And(sqlStr)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	}
	if task.OrdState != 3 {
		sess.In("state", state)
	}

	total, err := sess.Count(&model.B2cOrd{})
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
