package model

import (
	"time"
)

type UserLevelOrd struct {
	Id         int64     `json:"id" xorm:"pk autoincr comment('订单id') BIGINT(22)"`
	Uid        int       `json:"uid" xorm:"not null default 0 comment('uid') INT(10)"`
	TaskId     int       `json:"task_id" xorm:"not null comment('任务id（对应 user_level_upgrade_task 中Id）') INT(11)"`
	LevelId    int       `json:"level_id" xorm:"not null default 0 comment('等级id') INT(10)"`
	PayAmount  string    `json:"pay_amount" xorm:"not null default 0 comment('付费金额') DECIMAL(2)"`
	PayChannel int       `json:"pay_channel" xorm:"not null default 0 comment('1:支付宝,2:微信,3:余额') TINYINT(1)"`
	DateType   int       `json:"date_type" xorm:"not null default 0 comment('1:包月,2:包季,3:包年,4:永久') TINYINT(1)"`
	State      int       `json:"state" xorm:"not null default 0 comment('支付状态:0未支付1已支付') TINYINT(1)"`
	OrderType  int       `json:"order_type" xorm:"not null default 1 comment('订单类型（1是开通，2是续费）') TINYINT(3)"`
	CreateAt   time.Time `json:"create_at" xorm:"not null default CURRENT_TIMESTAMP comment('创建时间') TIMESTAMP"`
	ExpireAt   time.Time `json:"expire_at" xorm:"not null default CURRENT_TIMESTAMP comment('过期时间') TIMESTAMP"`
	SettleAt   int       `json:"settle_at" xorm:" default 0 comment('平台结算时间') INT(11)"`
}
